diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index a54b89b08..295b1be1a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -4,10 +4,12 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -35,8 +37,8 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockId(final @NotNull TilePos tilePos, final int id) {
-        this.blockEntryMap.put(tilePos, new BlockEntry(id, 0, null));
+    public boolean setBlockId(final @NotNull TilePosc tilePos, final int id) {
+        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(id, 0, null));
         return true;
     }
 
@@ -51,49 +53,49 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockData(final @NotNull TilePos tilePos, final int data) {
+    public boolean setBlockData(final @NotNull TilePosc tilePos, final int data) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             entry.data = data;
         } else {
-            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), data, this.world.getTileEntity(tilePos)));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), data, this.world.getTileEntity(tilePos)));
         }
 
         return true;
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull TilePos tilePos, final int id, final int data) {
-        this.blockEntryMap.put(tilePos, new BlockEntry(id, data, null));
+    public boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data) {
+        this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(id, data, null));
         return true;
     }
 
     @Override
-    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value) {
+    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value) {
         // Do nothing
     }
 
     @Override
-    public void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+    public void setTileEntity(final @NotNull TilePosc tilePos, final @NotNull TileEntity tileEntity) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             entry.tileEntity = tileEntity;
         } else {
-            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), tileEntity));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), tileEntity));
         }
     }
 
     @Override
-    public void removeTileEntity(final @NotNull TilePos tilePos) {
+    public void removeTileEntity(final @NotNull TilePosc tilePos) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             entry.tileEntity = null;
         } else {
-            this.blockEntryMap.put(tilePos, new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), null));
+            this.blockEntryMap.put(new TilePos(tilePos), new BlockEntry(this.world.getBlockId(tilePos), this.world.getBlockData(tilePos), null));
         }
     }
 
-    public @Nullable BlockEntry getEntry(final @NotNull TilePos tilePos) {
+    public @Nullable BlockEntry getEntry(final @NotNull TilePosc tilePos) {
         return this.blockEntryMap.get(tilePos);
     }
 
@@ -111,7 +113,7 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePos tilePos) {
+    public int getBlockId(final @NotNull TilePosc tilePos) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             return entry.id;
@@ -121,12 +123,12 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
         return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             return entry.tileEntity;
@@ -136,7 +138,7 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+    public float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission) {
         if (this.lightRefEntity != null) {
             return this.lightRefEntity.getBrightness(1.0f);
         }
@@ -145,7 +147,7 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
         if (this.lightRefEntity != null) {
             return this.lightRefEntity.getLightmap(1.0f);
         }
@@ -159,12 +161,12 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public float getLightBrightness(final @NotNull TilePos tilePos) {
+    public float getLightBrightness(final @NotNull TilePosc tilePos) {
         return this.world.getLightBrightness(tilePos);
     }
 
     @Override
-    public int getBlockData(final @NotNull TilePos tilePos) {
+    public int getBlockData(final @NotNull TilePosc tilePos) {
         final @Nullable BlockEntry entry = this.getEntry(tilePos);
         if (entry != null) {
             return entry.data;
@@ -174,39 +176,39 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos) {
+    public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block == null) {
-            return Material.air;
+            return Materials.AIR;
         } else {
             return block.getMaterial();
         }
     }
 
     @Override
-    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         return block != null && block.isSolidRender();
     }
 
     @Override
-    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
     @Override
-    public double getBlockTemperature(final @NotNull TilePos tilePos) {
+    public double getBlockTemperature(final @NotNull TilePosc tilePos) {
         return this.world.getBlockTemperature(tilePos);
     }
 
     @Override
-    public double getBlockHumidity(final @NotNull TilePos tilePos) {
+    public double getBlockHumidity(final @NotNull TilePosc tilePos) {
         return this.world.getBlockHumidity(tilePos);
     }
 
     @Override
-    public double getBlockVariety(final @NotNull TilePos tilePos) {
+    public double getBlockVariety(final @NotNull TilePosc tilePos) {
         return this.world.getBlockVariety(tilePos);
     }
 
@@ -216,12 +218,12 @@ public class BlocksContainer implements MutableWorldSource {
     }
 
     @Override
-    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos) {
+    public @NotNull Biome getBlockBiome(final @NotNull TilePosc tilePos) {
         return this.world.getBlockBiome(tilePos);
     }
 
     @Override
-    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos) {
         return this.world.getSavedLightValue(lightLayer, tilePos);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index e74c5c8be..6677a4c1c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -10,100 +10,103 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.util.helper.DamageType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.*;
 
 public class Explosion {
 
-	public boolean isFlaming;
-	protected Random ExplosionRNG;
-	protected World worldObj;
-	public double explosionX;
-	public double explosionY;
-	public double explosionZ;
-	public Entity exploder;
-	public float explosionSize;
-	public Set<ChunkPosition> destroyedBlockPositions;
-	public boolean destroyBlocks;
-
-	public Explosion(World world, Entity entity, double x, double y, double z, float explosionSize) {
-		isFlaming = false;
-		ExplosionRNG = new Random();
-		destroyedBlockPositions = new HashSet<>();
-		worldObj = world;
-		exploder = entity;
-		this.explosionSize = explosionSize;
-		explosionX = x;
-		explosionY = y;
-		explosionZ = z;
-		destroyBlocks = true;
-		if(!world.getGameRuleValue(GameRules.MOB_GRIEFING)) {
-		    destroyBlocks = entity == null || entity instanceof Player;
-		}
-	}
-
-	public void explode() {
-	    calculateBlocksToDestroy();
-	    
-		damageEntities();
-		
-		if(destroyBlocks && isFlaming) createFire();
-	}
+    protected final @NotNull World world;
+    public final @Nullable Entity exploder;
+    public boolean isFlaming;
+    protected Random ExplosionRNG;
+    public double explosionX;
+    public double explosionY;
+    public double explosionZ;
+    public float explosionSize;
+    public Set<ChunkPosition> destroyedBlockPositions;
+    public boolean destroyBlocks;
+
+    public Explosion(@NotNull World world, @Nullable Entity exploder, double x, double y, double z, float explosionSize) {
+        this.isFlaming = false;
+        this.ExplosionRNG = new Random();
+        this.destroyedBlockPositions = new HashSet<>();
+        this.world = world;
+        this.exploder = exploder;
+        this.explosionSize = explosionSize;
+        this.explosionX = x;
+        this.explosionY = y;
+        this.explosionZ = z;
+        this.destroyBlocks = true;
+        if (!world.getGameRuleValue(GameRules.MOB_GRIEFING)) {
+            this.destroyBlocks = exploder == null || exploder instanceof Player;
+        }
+    }
+
+    public void explode() {
+        calculateBlocksToDestroy();
+
+        damageEntities();
+
+        if (this.destroyBlocks && this.isFlaming) createFire();
+    }
 
     public void addEffects(boolean particles) {
-    	if(!worldObj.isClientSide) {
-    		worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, explosionX, explosionY, explosionZ, "random.explode", 4F, (1.0F + (worldObj.rand.nextFloat() - worldObj.rand.nextFloat()) * 0.2F) * 0.7F);	
-    	}
-        List<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
+        if (!this.world.isClientSide) {
+            this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, this.explosionX, this.explosionY, this.explosionZ, "random.explode", 4F, (1.0F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.2F) * 0.7F);
+        }
+        List<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
         for (int i = arraylist.size() - 1; i >= 0; i--) {
             ChunkPosition chunkposition = arraylist.get(i);
-            
+
             int x = chunkposition.x;
             int y = chunkposition.y;
             int z = chunkposition.z;
-            
-            TileEntity tileEntity = worldObj.getTileEntity(x, y, z);
-            if(particles) {
-                double xPos = (double) x + worldObj.rand.nextFloat();
-                double yPos = (double) y + worldObj.rand.nextFloat();
-                double zPos = (double) z + worldObj.rand.nextFloat();
-                double d3 = xPos - explosionX;
-                double d4 = yPos - explosionY;
-                double d5 = zPos - explosionZ;
+
+            TileEntity tileEntity = this.world.getTileEntity(x, y, z);
+            if (particles) {
+                double xPos = (double) x + this.world.rand.nextFloat();
+                double yPos = (double) y + this.world.rand.nextFloat();
+                double zPos = (double) z + this.world.rand.nextFloat();
+                double d3 = xPos - this.explosionX;
+                double d4 = yPos - this.explosionY;
+                double d5 = zPos - this.explosionZ;
                 double d6 = MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
                 d3 /= d6;
                 d4 /= d6;
                 d5 /= d6;
-                double d7 = 0.5D / (d6 / (double) explosionSize + 0.1D);
-                d7 *= worldObj.rand.nextFloat() * worldObj.rand.nextFloat() + 0.3F;
+                double d7 = 0.5D / (d6 / (double) this.explosionSize + 0.1D);
+                d7 *= this.world.rand.nextFloat() * this.world.rand.nextFloat() + 0.3F;
                 d3 *= d7;
                 d4 *= d7;
                 d5 *= d7;
-                worldObj.spawnParticle("explode", (xPos + explosionX) / 2D, (yPos + explosionY) / 2D, (zPos + explosionZ) / 2D, d3, d4, d5, 0);
-                worldObj.spawnParticle("smoke", xPos, yPos, zPos, d3, d4, d5, 0);
+                this.world.spawnParticle("explode", (xPos + this.explosionX) / 2D, (yPos + this.explosionY) / 2D, (zPos + this.explosionZ) / 2D, d3, d4, d5, 0);
+                this.world.spawnParticle("smoke", xPos, yPos, zPos, d3, d4, d5, 0);
             }
-            if (destroyBlocks) {
-                Block<?> block = worldObj.getBlock(x, y, z);
-                if(block != null)
-                {
-                    block.dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity, null);
-                    worldObj.setBlockWithNotify(x, y, z, 0);
-                    block.onBlockDestroyedByExplosion(worldObj, x, y, z);
+            if (this.destroyBlocks) {
+                Block<?> block = this.world.getBlock(x, y, z);
+                if (block != null) {
+                    block.dropBlockWithCause(this.world, EnumDropCause.EXPLOSION, x, y, z, this.world.getBlockMetadata(x, y, z), tileEntity, null);
+                    this.world.setBlockWithNotify(x, y, z, 0);
+                    block.onBlockDestroyedByExplosion(this.world, x, y, z);
                 }
             }
         }
     }
-	
-	protected void calculateBlocksToDestroy() {
+
+    protected void calculateBlocksToDestroy() {
         int i = 16;
         for (int j = 0; j < i; j++) {
             for (int l = 0; l < i; l++) {
-                label0: for (int j1 = 0; j1 < i; j1++) {
-                    if(j != 0 && j != i - 1 && l != 0 && l != i - 1 && j1 != 0 && j1 != i - 1) {
+                label0:
+                for (int j1 = 0; j1 < i; j1++) {
+                    if (j != 0 && j != i - 1 && l != 0 && l != i - 1 && j1 != 0 && j1 != i - 1) {
                         continue;
                     }
                     double d = ((float) j / ((float) i - 1.0F)) * 2.0F - 1.0F;
@@ -113,24 +116,24 @@ public class Explosion {
                     d /= d3;
                     d1 /= d3;
                     d2 /= d3;
-                    float f1 = explosionSize * (0.7F + worldObj.rand.nextFloat() * 0.6F);
-                    double d5 = explosionX;
-                    double d7 = explosionY;
-                    double d9 = explosionZ;
+                    float f1 = this.explosionSize * (0.7F + this.world.rand.nextFloat() * 0.6F);
+                    double d5 = this.explosionX;
+                    double d7 = this.explosionY;
+                    double d9 = this.explosionZ;
                     float f2 = 0.3F;
-                    while(true) {
-                        if(f1 <= 0.0F) {
+                    while (true) {
+                        if (f1 <= 0.0F) {
                             continue label0;
                         }
                         int j4 = MathHelper.floor(d5);
                         int k4 = MathHelper.floor(d7);
                         int l4 = MathHelper.floor(d9);
-                        int i5 = worldObj.getBlockId(j4, k4, l4);
-                        if(i5 > 0) {
-                            f1 -= (Blocks.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
+                        int i5 = this.world.getBlockId(j4, k4, l4);
+                        if (i5 > 0) {
+                            f1 -= (Blocks.blocksList[i5].getBlastResistance(this.exploder) + 0.3F) * f2;
                         }
-                        if(f1 > 0.0F) {
-                            destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
+                        if (f1 > 0.0F) {
+                            this.destroyedBlockPositions.add(new ChunkPosition(j4, k4, l4));
                         }
                         d5 += d * (double) f2;
                         d7 += d1 * (double) f2;
@@ -140,33 +143,33 @@ public class Explosion {
                 }
             }
         }
-	}
-	
-	protected void damageEntities() {
-        float explosionSize2 = explosionSize * 2.0f;
-        
-        int x1 = MathHelper.floor(explosionX - (double) explosionSize2 - 1.0D);
-        int x2 = MathHelper.floor(explosionX + (double) explosionSize2 + 1.0D);
-        int y1 = MathHelper.floor(explosionY - (double) explosionSize2 - 1.0D);
-        int y2 = MathHelper.floor(explosionY + (double) explosionSize2 + 1.0D);
-        int z1 = MathHelper.floor(explosionZ - (double) explosionSize2 - 1.0D);
-        int z2 = MathHelper.floor(explosionZ + (double) explosionSize2 + 1.0D);
-        
-        List<Entity> list = new ArrayList<>(worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.fromPool(x1, y1, z1, x2, y2, z2)));
-        Vec3 vec3 = Vec3.fromPool(explosionX, explosionY, explosionZ);
+    }
+
+    protected void damageEntities() {
+        float explosionSize2 = this.explosionSize * 2.0f;
+
+        int x1 = MathHelper.floor(this.explosionX - (double) explosionSize2 - 1.0D);
+        int x2 = MathHelper.floor(this.explosionX + (double) explosionSize2 + 1.0D);
+        int y1 = MathHelper.floor(this.explosionY - (double) explosionSize2 - 1.0D);
+        int y2 = MathHelper.floor(this.explosionY + (double) explosionSize2 + 1.0D);
+        int z1 = MathHelper.floor(this.explosionZ - (double) explosionSize2 - 1.0D);
+        int z2 = MathHelper.floor(this.explosionZ + (double) explosionSize2 + 1.0D);
+
+        List<Entity> list = new ArrayList<>(this.world.getEntitiesWithinAABBExcludingEntity(this.exploder, new AABBd(x1, y1, z1, x2, y2, z2)));
+        Vector3dc vec3 = new Vector3d(this.explosionX, this.explosionY, this.explosionZ);
         for (Entity entity : list) {
-            double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double) explosionSize2;
+            double d4 = entity.distanceTo(this.explosionX, this.explosionY, this.explosionZ) / (double) explosionSize2;
             if (d4 <= 1.0D) {
-                double xComp = entity.x - explosionX;
-                double yComp = entity.y - explosionY;
-                double zComp = entity.z - explosionZ;
+                double xComp = entity.x - this.explosionX;
+                double yComp = entity.y - this.explosionY;
+                double zComp = entity.z - this.explosionZ;
                 double distance = MathHelper.sqrt(xComp * xComp + yComp * yComp + zComp * zComp);
                 xComp /= distance;
                 yComp /= distance;
                 zComp /= distance;
-                double d12 = worldObj.getSeenPercent(vec3, entity.bb);
+                double d12 = this.world.getSeenPercent(vec3, entity.bb);
                 double d13 = (1.0D - d4) * d12;
-                entity.hurt(exploder, (int) (((d13 * d13 + d13) / 2D) * 8D * (double) explosionSize2 + 1.0D), DamageType.BLAST);
+                entity.hurt(this.exploder, (int) (((d13 * d13 + d13) / 2D) * 8D * (double) explosionSize2 + 1.0D), DamageType.BLAST);
                 double flingForce = d13 * 2;
                 if (entity instanceof IArmorWearing) {
                     float proc = 1 - (((IArmorWearing<?>) entity).getTotalProtectionAmount(DamageType.BLAST) / 2f);
@@ -175,20 +178,20 @@ public class Explosion {
                 entity.fling(xComp * flingForce, yComp * flingForce, zComp * flingForce, 1);
             }
         }
-	}
-
-	protected void createFire() {
-        List<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
-		for (int l2 = arraylist.size() - 1; l2 >= 0; l2--) {
-			ChunkPosition chunkposition = arraylist.get(l2);
-			
-			int x1 = chunkposition.x;
-			int y1 = chunkposition.y;
-			int z1 = chunkposition.z;
-			
-			if(worldObj.getBlockId(x1, y1, z1) == 0 && Blocks.solid[worldObj.getBlockId(x1, y1 - 1, z1)] && ExplosionRNG.nextInt(3) == 0) {
-				worldObj.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
-			}
-		}
-	}
+    }
+
+    protected void createFire() {
+        List<ChunkPosition> arraylist = new ArrayList<>(this.destroyedBlockPositions);
+        for (int l2 = arraylist.size() - 1; l2 >= 0; l2--) {
+            ChunkPosition chunkposition = arraylist.get(l2);
+
+            int x1 = chunkposition.x;
+            int y1 = chunkposition.y;
+            int z1 = chunkposition.z;
+
+            if (this.world.getBlockId(x1, y1, z1) == 0 && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.ExplosionRNG.nextInt(3) == 0) {
+                this.world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
+            }
+        }
+    }
 }
